#include <QPainter>
#include <QComboBox>
#include <QDebug>

#include "departdelegate.h"

departDelegate::departDelegate(QObject */*parent*/)
{
}

void departDelegate::paint ( QPainter * painter, const QStyleOptionViewItem  & option, const QModelIndex & index ) const
{
    QStyleOptionViewItem opt = option;
    QString gares = index.model()->data(index,Qt::DisplayRole).toString();
    QStringList listeGares = gares.split(',');
    opt.displayAlignment = Qt::AlignCenter;
    if (listeGares.size() > 0)
    {
        painter->drawText(opt.rect,Qt::AlignCenter,listeGares.at(0));
    }
}

QSize departDelegate::sizeHint ( const QStyleOptionViewItem  & option, const QModelIndex & index ) const
{
    QPainter *painter = new QPainter();
    QString gares = index.model()->data(index,Qt::DisplayRole).toString();
    QStringList listeGares = gares.split(',');
    if (listeGares.size() > 0)
    {
        QRect rect;
        painter->drawText(option.rect,Qt::AlignCenter,listeGares.at(0),&rect);
        //qDebug () << "size: " << rect.size();
        return QSize(300,50); //rect.size(); // faudrait voir à corriger ça quand même ...
    }
    return QSize();
}

QWidget *departDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &/*option*/, const QModelIndex &/*index*/) const
{    
    QComboBox *combo = new QComboBox(parent);
    return combo;

}

void departDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    QComboBox *combo = static_cast<QComboBox*>(editor);
    QString gares = index.model()->data(index,Qt::DisplayRole).toString();
    QStringList listeGares = gares.split(',');
    combo->addItems(listeGares);
}
